# include "stdio.h"
# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX 200
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng; extern char yytext[];
int yymorfg;
extern char *yysptr, yysbuf[];
int yytchar;
FILE *yyin ={stdin}, *yyout ={stdout};
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
/* ----------------------------- Global Definitions ------------------------ */
/* ------------------------------------------------------------------------- */

#undef   input

#include <stdio.h>
#include <dos.h>
#include <ctype.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>

#include "ncform.h"
#include "stdhdr.h"

int   start     = FALSE;
int   Syntax    = FALSE;
int   V3Item    = FALSE;
int   V3Count   = 0;
int   Total     = 0;
int   ItemCount = 0;                    /* Number of items in input file.    */
char  *End;

char  Name[64];

int main (int, char **);
void  SelectOutput (void);
unsigned int Hash  (char *);
void InitOutput (void);
void GrowPSP (int);
void InitDescList(void);
char * GetDescription (unsigned, char *);

typedef struct {
   char     *Name;
   char     *String;
   unsigned HashCode;
   FILE     *File;
} SECTION;

/*
** The following type definition is used to allow the user to define the short
** description that will follow the topic name when the list of available
** topics is displayed.  Be advised that the number of entries subortinate to
** a sungle menu item in the Norton Guides determines the ammout of text that
** can be provided for the short descriptions.  Do to the fact that the
** FUNCTIONS list has over 500 function calls documented, short descriptions
** cannot be readily provided due to memory problems when attempting to compile
** the resulting Norton Guide database.  I have provided a TOPICS list for the
** window messages (see file MESSAGES.DSC).  The first element in this file
** is the number of entries in the file (i.e. # of lines), followed by the
** item name and short description for that item.
*/
typedef struct {
   char     *ItemName;                  /* Name of "!short" item.            */
   char     *Header;                    /* Short description to use.         */
   unsigned HashCode;
} HEADERS;
HEADERS  *HdrList;                      /* Allocated array of headers.       */

SECTION  Current;
SECTION  Section[] = {
   { "function.dat",  "AccessResource"},
   { "messages.dat",  "BM_GETCHECK"},
   { "typedefs.dat",  "BITMAP"},
   { "datatype.dat",  "Data Types"},
   { "wndstyle.dat",  "Control Classes"},
   { "function.dat",  "CreateWindowEx"},
   { "macros.dat",    "HIBYTE"},
   { "function.dat",  "HideCaret"},
   { "macros.dat",    "HIWORD"},
   { "function.dat",  "InflateRect"},
   { "macros.dat",    "LOBYTE"},
   { "function.dat",  "LocalAlloc"},
   { "macros.dat",    "LOWORD"},
   { "function.dat",  "LPtoDP"},
   { "macros.dat",    "MAKEINTATOM"},
   { "function.dat",  "MakeProcInstance"},
   { "macros.dat",    "max"},
   { "function.dat",  "MessageBeep"},
   { "macros.dat",    "min"},
   { "function.dat",  "ModifyMenu"},
   { "macros.dat",    "PALETTEINDEX"},
   { "function.dat",  "PatBlt"},
   { "macros.dat",    "RGB"},
   { "function.dat",  "RoundRect"},
   { "mem32bit.dat",  "GetWinMem32Version"},
   { "mem32bit.dat",  "Using the WINMEM32.DLL Library"},
   { "prnescps.dat",  "Printer Escapes"},
   { "fatalxit.dat",  "Fatal Exit Codes"},
   { "messgovr.dat",  "Messages Overview"},
   { "vkeycode.dat",  "Virtual-Key Codes"},
   { "other.dat",     "Data Structures" },
   { "other.dat",     "Microsoft Windows Programmer\'s Reference"},
   { "other.dat",     "Message Functions"},
   { 0, 0, 0, 0 }
};

/* ----------------------------- Begin Productions ------------------------- */
/* ------------------------------------------------------------------------- */
# define YYNEWLINE 10
yylex(){
int nstr; extern int yyprevious;
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:
{
   start = TRUE;
}
break;
case 2:
{
   start = FALSE;
   V3Item = TRUE;
   End = strtok(&yytext[9], "\\");
   strcpy (Name, &yytext[9]);
   printf ("%04d (V3): ",++Total);
   SelectOutput();
}
break;
case 3:
{
   start = FALSE;
   V3Item = FALSE;
   End = strtok(&yytext[9], "\\");
   strcpy (Name, &yytext[9]);
   printf ("%04d (V2): ",++Total);
   SelectOutput();
}
break;
case 4:
{
   fprintf (yyout, "^BSyntax^B");
   Syntax = TRUE;
}
break;
case 5:
{
   fprintf (yyout, "^BReturn^B");
}
break;
case 6:
{
   fprintf (yyout, "^BNotes^B ");
}
break;
case 7:
{
   Syntax = FALSE;
   fprintf (yyout, ")\n");
}
break;
case 8:
{
   /*
   ** Ignore.
   */
}
break;
case 9:
{
   /*
   ** Ignore.
   */
}
break;
case 10:
{
   /*
   ** Output the body of the documentation block, if open.
   */
   if (start == FALSE) {
      putc (yytext[0], yyout);
   }
}
break;
case -1:
break;
default:
fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
 

/* -------------------------------- main() --------------------------------- */
/* ------------------------------------------------------------------------- */

PUBLIC main (int argc, char *argv[])
{
   unsigned int    status;
   char            buffer[80];
   char            drive[_MAX_DRIVE];
   char            dir[_MAX_DIR];
   char            fname[_MAX_FNAME];
   char            ext[_MAX_EXT];
   struct find_t   wildbuf;

   if (argc != 2) {
      fprintf (stderr, "NGCVT: Incorrect number of arguments.\n");
      fprintf (stderr, "Usage is: ngcvt <input file>\n");
      exit(1);
   }

   /*
   ** Find the first occurance of the requested file spec (which
   ** can be a wildcard).  Initialize the wildcard structures.
   */
   status = _dos_findfirst (argv[1], _A_NORMAL, &wildbuf);
   if (status) {
      fprintf (stderr, "NGCVT: Cannot find path.\n");
      exit (1);
   }

   _splitpath (argv[1], drive, dir, fname, ext);
   sprintf (buffer, "%s%s%s", drive, dir, wildbuf.name);
   yyin = fopen (buffer, "r");

   /*
   ** Open and initialize the output files.
   */
   GrowPSP (128);
   InitOutput();
   if (yyout == NULL) {
      fprintf (stderr, "NGCVT: Unable to open output file.\n");
      exit (1);
   }

   /*
   ** Initialize the short descriptions list from the input files.
   */
   InitDescList();

   /*
   ** Process each file.
   */
   GrowPSP (128);
   do {
      printf ("%s:\n", buffer);
      if (yyin == NULL) {
         fprintf (stderr, "NGCVT: Error Opening input file.\n");
         exit(1);
      }

      yylex ();
      printf ("\n");

      fclose (yyin);
      yylineno = 0;

   } while (_dos_findnext(&wildbuf) == 0);

   return (0);

}       /* main() */

/* -------------------------------- yywrap() ------------------------------- */
/* ------------------------------------------------------------------------- */

int yywrap ()
{
   return (1);

}

/* -------------------------------- input() -------------------------------- */
/* ------------------------------------------------------------------------- */
/*
**  Name        : input
**
**  Description : This function replaces the default LEX "input" macro with
**                something a little more sophisticated.  The need to do this
**                came about because of the inclusion of non-printable ASCII
**                characters (0xc4 and 0x04) appearing in the code.  This
**                made the LEX program I was using abort.
**
**  Returns     : Input character, as an integer.
**
**  Parameters  : None.
**
*/

int input (void)
{
   if (yysptr > yysbuf) {
      yytchar = U(*--yysptr);
   } else {
      yytchar = getc (yyin);
      if (yytchar == 0xc4) yytchar = (int)'-';
      if (yytchar == 0x04) yytchar = (int)'#';
   }

   if (yytchar == '\n') yylineno++;
   if (yytchar == EOF)  return (0);

   return (yytchar);

}     /* input() */

/* ------------------------------ SelectOutput() --------------------------- */
/* ------------------------------------------------------------------------- */
/*
**  Name        : SelectOutput
**
**  Description : This procedure selects, for each "subject" examined by the
**                lexical component, the appropriate output file.  The text
**                MACROS, and function, and certain tables, are all intermixed.
**                This procedure looks at the title of the subject and, if
**                the title is listed in the "Section" array, executes a
**                transition to a new output file.
**
**                All files are kept open at all times.  This is why I was
**                forced to write the "GrowPSP()" procedure, so that I could
**                be certain I would have enough file handles.
**
**                I use a simple hash code as a preliminary filter and then
**                perform a string comparison to detect collisions.  The
**                handle to the new file is stored in the data record which
**                contains the match.
**
**                If a description is available for the subject, it will be
**                written to the "!short" record in this procedure.
**
**  Returns     : None.
**
**  Parameters  : None.
**
*/

void SelectOutput (void)
{
   unsigned HashVal;
   int      i;
   char     *Description;

   /*
   ** Print the name of the selection.
   */
   printf ("%s\n",Name);

   /*
   ** Check to see if the current string is the delimiter phrase for a
   ** new section.  If so, then change the output file.
   */
   i = 0;
   HashVal = Hash (Name);
   while (Section[i].String != NULL) {
      if (HashVal == Section[i].HashCode) {
         if (strcmp(Name, Section[i].String) == 0) {
            Current = Section[i];
            break;
         }
      }
      i++;
   }

   yyout = Current.File;

   if ((Description = GetDescription(HashVal, Name)) != NULL) {
      fprintf (yyout, "\n!short:%-23s%s\n", Name, Description);
   } else {
      fprintf (yyout, "\n!short:%s\n", Name);
   }
   fprintf (yyout, "^BName^B    %s", Name);
   if (V3Item == TRUE) {
      fprintf (yyout, "\n\n        ^BVersion [3.0]^B\n");
   }

}     /* SelectOutput() */

/* ------------------------------ InitOutput() ----------------------------- */
/* ------------------------------------------------------------------------- */
/*
**  Name        : InitOutput
**
**  Description : Open all of the files defined in the "Section" array.  Be
**                careful not to attempt to open a file twice.  Save the file
**                handle in the "File" memot of the SECTION structure.
**
**  Returns     : None.
**
**  Parameters  : None.
**
**  Side Effects: The "File" member of the "Section" array is initialized.
**                The initial output file is assigned to the lex variable
**                "yyout".
**
*/

void InitOutput (void)
{
   int   i,j;

   i = 0;
   while (Section[i].String != NULL) {
      /*
      ** check to see if the file has been opened before.
      */
      for (j=0;j<i;j++) {
         if (strcmp(Section[j].Name,Section[i].Name) == 0) {
            Section[i].File = Section[j].File;
            break;
         }
      }

      /*
      ** If the current file pointer is NULL, the file has not yet been
      ** opened.  Attempt to open the file and report an error on failure.
      */
      if (Section[i].File == NULL) {
         Section[i].File = fopen (Section[i].Name, "w");
         if (Section[i].File == NULL) {
            fprintf (stderr, "NGCVT: Cannot open file (%s).\n", Section[i].String);
            exit (1);
         }
      }

      /*
      ** Calcualte the hash code for the section selector phrase, and then
      ** increment the count.
      */
      Section[i].HashCode = Hash(Section[i].String);
      i++;
   }

   yyout = Section[0].File;

}     /* InitOutput() */

/* --------------------------------- Hash() -------------------------------- */
/* ------------------------------------------------------------------------- */

unsigned int Hash (char *str)
{
   unsigned int hshval = 0;
   int length = strlen (str);

   while (*str) {
      hshval = ((hshval << 3) ^ tolower(*str)) ^ length;
      str++;
   }

   return (hshval);

}     /* Hash() */

/* --------------------------------- GrowPSP() ----------------------------- */
/* ------------------------------------------------------------------------- */

void GrowPSP (int NewSize)
{
   int   OldSize;
   int  *PSPHdlCnt;
   BYTE *NewHandle;
   BYTE **OldHandle;

   /*
   ** Set the new size of the handle block (in bytes).
   */
   FP_SEG(PSPHdlCnt) = _psp;
   FP_OFF(PSPHdlCnt) = 0x0032;
   OldSize = *PSPHdlCnt;
   *PSPHdlCnt = NewSize;

   /*
   ** Get the pointer to the old handle block.
   */
   FP_SEG(OldHandle) = _psp;
   FP_OFF(OldHandle) = 0x0034;
   NewHandle = calloc (NewSize, 1);

   /*
   ** Allocate the new handles, and copy the first five bytes from the
   ** old handle table to the new handle table.
   */
   memset (NewHandle, 0x00ff, NewSize);
   memcpy (NewHandle, *OldHandle, OldSize);

   /*
   ** Set the PSP to point to the new handle table.
   */
   *OldHandle = NewHandle;

}     /* GrowPSP() */

/* ------------------------------- InitDescList() -------------------------- */
/* ------------------------------------------------------------------------- */
/*
**  Name        : InitDescList
**
**  Description : Initialize the description list.  The list is an allocated
**                array of structures.  Each structre contains a pointer to
**                the item name to recieve the description and the second
**                pointer is to the actual description text.
**
**                The first line in the input file is the number of entries
**                in the description list.  This number is parsed and then
**                used to allocate the array of structures.
**
**  Returns     : None.
**
**  Parameters  : None.
**
*/
void InitDescList(void)
{
   FILE     *iFile;                     /* Input file.                       */
   int      i, j;                       /* Local Indicies.                   */
   char     ItemBuffer[48];             /* Character buffer for item name.   */
   char     DescBuffer[80];             /* Character buffer for description. */
   char     c;                          /* Current input character.          */

   iFile = fopen ("messages.dsc", "rt");
   if (iFile == NULL) {
      fprintf (stderr, "NGCVT: Unable to open input file MESSAGES.DSC.\n");
      return;
   }

   /*
   ** Scan the first line of the file for the number of entries in the
   ** input file.
   */
   fscanf (iFile,"%d\n", &ItemCount);
   if (ItemCount == 0) {
      fprintf (stderr, "NGCVT: Item count not defined or zero in MESSAGES.DSC.\n");
      fclose (iFile);
      return;
   }

   /*
   ** Now allocate the header array.
   */
   HdrList = calloc (ItemCount, sizeof(HEADERS));
   if (HdrList == NULL) {
      fprintf (stderr, "NGCVT: Could not allocate header array for MESSAGES.DSC.\n");
      fclose (iFile);
      return;
   }

   /*
   ** For each item define in the input file, scan the item into the buffers,
   ** and then duplicate the strings into the appropriate fields in the
   ** "HdrList" array.
   */
   for (i=0; i<ItemCount; i++) {
      j = 0;
      fscanf (iFile, "%s ", ItemBuffer);
      HdrList[i].ItemName = strdup(ItemBuffer);
      HdrList[i].HashCode = Hash (ItemBuffer);
      while ((c = (char)getc(iFile)) != '\n') DescBuffer[j++] = c;
      DescBuffer[j] = '\0';
      HdrList[i].Header   = strdup(DescBuffer);
   }

}        /* InitDescList() */

/* ------------------------------- GetDescription() ------------------------ */
/* ------------------------------------------------------------------------- */
/*
**  Name        : GetDescription
**
**  Description : Return a pointer to the short description for the subject
**                identified by the has code passed in as the first parameter.
**
**  Returns     : Pointer to the description string.
**
**  Parameters  : Unsigned integer hash code value for the target description.
**
*/
char * GetDescription (unsigned HashCode, char *Name)
{
   int   i;                             /* Local Index.                      */

   for (i=0; i<ItemCount; i++) {
      if (HdrList[i].HashCode == HashCode) {
         if (strcmp(Name, HdrList[i].ItemName) == 0) {
            return (HdrList[i].Header);
         }
      }
   }

   return (NULL);

}     /* GetDescription() */
int yyvstop[] ={
0,

10,
0,

10,
0,

10,
0,

10,
0,

10,
0,

10,
0,

7,
0,

8,
0,

8,
0,

9,
0,

4,
0,

1,
0,

3,
0,

6,
0,

3,
0,

3,
0,

3,
0,

3,
0,

5,
0,

3,
0,

3,
0,

3,
0,

3,
0,

3,
0,

3,
0,

3,
0,

3,
0,

3,
0,

2,
0,

2,
3,
0,
0};
# define YYTYPE char
struct yywork { YYTYPE verify, advance; } yycrank[] ={
0,0,	0,0,	1,3,	0,0,	
0,0,	0,0,	0,0,	0,0,	
50,53,	0,0,	0,0,	1,4,	
5,11,	22,28,	4,9,	23,29,	
35,40,	50,0,	53,56,	0,0,	
0,0,	0,0,	0,0,	75,56,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
56,56,	1,4,	28,34,	29,35,	
4,9,	10,16,	47,52,	50,53,	
53,57,	87,56,	1,5,	2,5,	
74,76,	75,77,	1,6,	2,6,	
2,8,	4,10,	6,12,	12,17,	
16,22,	17,23,	56,56,	57,53,	
60,53,	63,53,	0,0,	0,0,	
66,53,	69,53,	80,82,	87,57,	
57,56,	60,56,	63,56,	78,80,	
14,18,	66,56,	69,56,	82,84,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	14,19,	
14,20,	0,0,	57,57,	60,57,	
63,57,	52,55,	0,0,	66,57,	
69,57,	1,7,	2,7,	40,45,	
0,0,	0,0,	38,43,	7,13,	
8,15,	45,50,	19,25,	33,39,	
36,41,	55,58,	7,14,	59,62,	
56,59,	64,67,	24,30,	21,27,	
15,21,	7,13,	18,24,	26,32,	
30,36,	25,31,	27,33,	31,37,	
32,38,	37,42,	20,26,	39,44,	
41,46,	42,47,	43,48,	44,49,	
46,51,	51,54,	58,61,	61,64,	
62,65,	65,68,	68,70,	70,72,	
71,53,	72,74,	73,53,	76,78,	
57,60,	77,60,	79,53,	84,86,	
81,53,	71,56,	77,79,	73,56,	
83,53,	85,53,	0,0,	79,56,	
0,0,	81,56,	0,0,	0,0,	
60,63,	83,56,	85,56,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	69,71,	0,0,	71,57,	
0,0,	73,57,	63,66,	0,0,	
0,0,	79,57,	66,69,	81,57,	
0,0,	0,0,	0,0,	83,57,	
85,57,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	81,83,	0,0,	0,0,	
79,81,	0,0,	0,0,	83,85,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	85,87,	0,0,	0,0,	
0,0,	0,0,	71,73,	73,75,	
0,0};
struct yysvf yysvec[] ={
0,	0,	0,
yycrank+-1,	0,		0,	
yycrank+-2,	yysvec+1,	0,	
yycrank+0,	0,		yyvstop+1,
yycrank+4,	0,		yyvstop+3,
yycrank+2,	0,		yyvstop+5,
yycrank+5,	0,		yyvstop+7,
yycrank+1,	0,		yyvstop+9,
yycrank+1,	0,		yyvstop+11,
yycrank+0,	yysvec+4,	0,	
yycrank+2,	0,		0,	
yycrank+0,	0,		yyvstop+13,
yycrank+6,	0,		0,	
yycrank+0,	0,		yyvstop+15,
yycrank+1,	0,		yyvstop+17,
yycrank+1,	0,		0,	
yycrank+7,	0,		0,	
yycrank+8,	0,		0,	
yycrank+3,	0,		0,	
yycrank+1,	0,		0,	
yycrank+1,	0,		0,	
yycrank+1,	0,		0,	
yycrank+3,	0,		0,	
yycrank+5,	0,		0,	
yycrank+1,	0,		0,	
yycrank+1,	0,		0,	
yycrank+5,	0,		0,	
yycrank+2,	0,		0,	
yycrank+2,	0,		0,	
yycrank+3,	0,		0,	
yycrank+7,	0,		0,	
yycrank+2,	0,		0,	
yycrank+4,	0,		0,	
yycrank+2,	0,		0,	
yycrank+0,	0,		yyvstop+19,
yycrank+6,	0,		0,	
yycrank+3,	0,		0,	
yycrank+7,	0,		0,	
yycrank+1,	0,		0,	
yycrank+3,	0,		0,	
yycrank+3,	0,		0,	
yycrank+14,	0,		0,	
yycrank+15,	0,		0,	
yycrank+6,	0,		0,	
yycrank+11,	0,		0,	
yycrank+3,	0,		0,	
yycrank+12,	0,		0,	
yycrank+6,	0,		0,	
yycrank+0,	0,		yyvstop+21,
yycrank+0,	0,		yyvstop+23,
yycrank+-7,	0,		0,	
yycrank+14,	0,		0,	
yycrank+3,	0,		0,	
yycrank+-8,	yysvec+50,	yyvstop+25,
yycrank+0,	0,		yyvstop+27,
yycrank+8,	0,		0,	
yycrank+22,	0,		0,	
yycrank+-54,	0,		yyvstop+29,
yycrank+22,	0,		0,	
yycrank+6,	0,		0,	
yycrank+-55,	0,		yyvstop+31,
yycrank+14,	0,		0,	
yycrank+18,	0,		0,	
yycrank+-56,	0,		yyvstop+33,
yycrank+8,	0,		0,	
yycrank+18,	0,		0,	
yycrank+-59,	0,		yyvstop+35,
yycrank+0,	0,		yyvstop+37,
yycrank+29,	0,		0,	
yycrank+-60,	0,		yyvstop+39,
yycrank+24,	0,		0,	
yycrank+-135,	0,		yyvstop+41,
yycrank+27,	0,		0,	
yycrank+-137,	0,		yyvstop+43,
yycrank+12,	0,		0,	
yycrank+-13,	yysvec+50,	yyvstop+45,
yycrank+48,	0,		0,	
yycrank+-55,	yysvec+57,	yyvstop+47,
yycrank+16,	0,		0,	
yycrank+-141,	0,		yyvstop+49,
yycrank+16,	0,		0,	
yycrank+-143,	0,		yyvstop+51,
yycrank+23,	0,		0,	
yycrank+-147,	0,		yyvstop+53,
yycrank+50,	0,		0,	
yycrank+-148,	0,		yyvstop+55,
yycrank+0,	0,		yyvstop+57,
yycrank+-31,	yysvec+50,	yyvstop+59,
0,	0,	0};
struct yywork *yytop = yycrank+247;
struct yysvf *yybgin = yysvec+1;
char yymatch[] ={
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,012 ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
040 ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
0};
char yyextra[] ={
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};

/*      ncform  4.1     83/08/11        */


/* --------------------------- Declarations() ------------------------------ */
/* ------------------------------------------------------------------------- */

int yylineno =1;

# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE

char yytext[YYLMAX];
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
char yysbuf[YYLMAX];
char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;

/* ------------------------------- yylook() -------------------------------- */
/* ------------------------------------------------------------------------- */

int yylook(void)
{
   register struct yysvf *yystate, **lsp;
   register struct yywork *yyt;
   struct yysvf *yyz;
   struct yywork *yyr;
   int yych;
   char *yylastch;

   /*
   ** Start off machines.
   */
   if (!yymorfg) {
      yylastch = yytext;
   } else {
      yymorfg=0;
      yylastch = yytext+yyleng;
   }

   for (;;) {
      lsp = yylstate;
      yyestate = yystate = yybgin;
      if (yyprevious==YYNEWLINE) yystate++;
      for (;;) {
         yyt = yystate->yystoff;

         /*
         ** May not be any transitions.
         */
         if(yyt == yycrank){
            yyz = yystate->yyother;
            if(yyz == 0)break;
            if(yyz->yystoff == yycrank)break;
         }
         *yylastch++ = (char)(yych = input());

         tryagain:

         yyr = yyt;
         if (yyt > yycrank) {
            yyt = yyr + yych;
            if (yyt <= yytop && yyt->verify+yysvec == yystate) {

               /*
               ** Error transitions.
               */
               if(yyt->advance+yysvec == YYLERR) {
                  unput(*--yylastch);
                  break;
               }

               *lsp++ = yystate = yyt->advance+yysvec;
               goto contin;
            }
         }
# ifdef YYOPTIM
         else if (yyt < yycrank) {              /* r < yycrank */
            yyt = yyr = yycrank+(yycrank-yyt);
            yyt = yyt + yych;

            if(yyt <= yytop && yyt->verify+yysvec == yystate) {
               /*
               ** Error transitions.
               */
               if(yyt->advance+yysvec == YYLERR) {
                  unput(*--yylastch);
                  break;
               }

               *lsp++ = yystate = yyt->advance+yysvec;
               goto contin;
            }

            yyt = yyr + YYU(yymatch[yych]);
            if (yyt <= yytop && yyt->verify+yysvec == yystate) {
               /*
               ** Error transition.
               */
               if (yyt->advance+yysvec == YYLERR) {
                  unput(*--yylastch);
                  break;
               }

               *lsp++ = yystate = yyt->advance+yysvec;
               goto contin;
            }
         }

         if ((yystate=yystate->yyother) && (yyt=yystate->yystoff) != yycrank) {
            goto tryagain;
         }
# endif
         else {
            unput(*--yylastch);
            break;
         }

         contin:;
      }

      while (lsp-- > yylstate){
         *yylastch-- = 0;
         if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
            yyolsp = lsp;

            /*
            ** Must backup.
            */
            if(yyextra[*yyfnd]){
               while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate) {
                  lsp--;
                  unput(*yylastch--);
               }
            }
            yyprevious = YYU(*yylastch);
            yylsp = lsp;
            yyleng = yylastch-yytext+1;
            yytext[yyleng] = 0;
            return(*yyfnd++);
         }
         unput(*yylastch);
      }

      if (yytext[0] == 0) {
         yysptr=yysbuf;
         return(0);
      }

      yyprevious = yytext[0] = input();
      if (yyprevious>0) output(yyprevious);
      yylastch=yytext;
   }

}     /* yylook() */

/* ------------------------------- yyback() -------------------------------- */
/* ------------------------------------------------------------------------- */

int yyback (int *p, int m)
{
   if (p==0) return(0);
   while (*p) {
      if (*p++ == m) {
         return(1);
      }
   }

   return(0);

}     /* yyback() */

/* ------------------------------- yyinput() ------------------------------- */
/* ------------------------------------------------------------------------- */

int yyinput (void)
{

   return(input());

}     /* yyinput() */

/* ------------------------------- yyoutput() ------------------------------ */
/* ------------------------------------------------------------------------- */

int yyoutput (int c)
{

   output(c);

}     /* yyoutput() */

/* ------------------------------- yyunput() ------------------------------- */
/* ------------------------------------------------------------------------- */

int yyunput (int c)
{

   unput(c);

}     /* yyunput() */
